#include <GlobalNodeList.h>
#include <OverSwarm.h>
#include "OvSwTemplateSampleLib.h"
#include "OverSwarmTemplate.h"

using namespace overswarm;

namespace oversim {

Define_Module(OvSwTemplateSampleLib);

void OvSwTemplateSampleLib::initialize(int stage)
{
    if(stage != MIN_STAGE_OVERLAY)
        return;

    OvSwList* l = new OvSwList();
    l->push_back(wrap("Hello"));
    l->push_back(wrap("World"));

    dummylist = wrap(l);

    WATCH(dummylist);
}

OvSwValue::Ptr OvSwTemplateSampleLib::nodeId(void* owner, OvSwStack* st)
{
	OverSwarmTemplate* ovs = static_cast<OverSwarmTemplate*>(owner);
	if (this->id == NULL) {
		this->id = wrap(ovs->thisNode);
	}
	return OvSwValue::Ptr(this->id);
}

OvSwValue::Ptr OvSwTemplateSampleLib::getRandomNodes(void* owner, OvSwStack* st)
{
	OverSwarmTemplate* ovs = static_cast<OverSwarmTemplate*>(owner);
	OvSwList* l = new OvSwList();
	l->push_back(wrap(*ovs->globalNodeList->getRandomAliveNode()));
	l->push_back(wrap(*ovs->globalNodeList->getRandomAliveNode()));
	return wrap(l);
}

OvSwValue::Ptr OvSwTemplateSampleLib::say(void* owner, OvSwStack* st, OvSwValue::Ptr msg)
{
	cout << *msg << endl;

	return OVSWFALSE;
}

}

